
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>grails中使用group by后的totalCount问题 / 憋错料</title>

    <meta name="description" content="grails中使用group by后的totalCount问题 一.totalCount 最近在用grails开发项目,在createCriteria中使用group by的时候发现PagedResultList中的totalCount有问题. 查阅了很多官方的非官方的资料后,最终得出一条临时方便的解决办法: int totalCount = Domain.executeQuery('select count(*) from domain where id in(select min(id) from domain group by grp1,grp2))'">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">grails中使用group by后的totalCount问题</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>一、totalCount</p>
<p>最近在用grails开发项目，在createCriteria中使用group by的时候发现PagedResultList中的totalCount有问题。</p>
<p>查阅了很多官方的非官方的资料后，最终得出一条临时方便的解决办法：</p>
<p>int totalCount = Domain.executeQuery(‘select count(*) from<br />
domain where id in(select min(id) from domain group by<br />
grp1,grp2))‘)[0]</p>
<p>domain:你的domain的名称，注意大小写</p>
<p>grp1,grp2:你的group by 字段，注意大小写</p>
<p>二、顺便再记录一个</p>
<p>在createCriteria中使用group by 返回的聚合数据不是map的问题解决方法：</p>
<p>def results = Domain.createCriteria.list(max:10,offset:0){</p>
<p>setResultTransformer(CriteriaSpecification.ALIAS_TO_ENTITY_MAP)</p>
<p>projections{</p>
<p>groupProperty(&quot;grp1&quot;)</p>
<p>sum(&quot;sum1&quot;,&quot;sum1&quot;)</p>
<p>}</p>
<p>}</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 17:38:06 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/hql/" title="hql">hql</a>, <a href="https://www.biecuoliao.com/tag/group-by/" title="group by">group by</a>, <a href="https://www.biecuoliao.com/tag/grails/" title="grails">grails</a>, <a href="https://www.biecuoliao.com/tag/createcriteria/" title="createcriteria">createcriteria</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>grails中使用group by后的totalCount问题的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4185vP3.html" rel="bookmark">sql中的group by 和 having 用法解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--sql中的group by 用法解析:-- Group By语句从英文的字面意义上理解就是“根据(by)一定的规则进行分组(Group)”.--它的作用是通过一定的规则将一个数据集划分成若干个小的区域,然后针对若干个小区域进行数据处理.--注意:group by 是先排序后分组:--举例子说明:如果要用到group by 一般用到的就是“每这个字” 例如说明现在有一个这样的表:每个部门有多少人 就要用到分组的技术select DepartmentID as '部门名称',COUNT(*) a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Jyl7Q3.html" rel="bookmark">SQL 中的group by （转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 原始表 简单Group By Group By 和 Order By Group By中Select指定的字段限制 Group By All Group By与聚合函数 Having与Where的区别 Compute 和 Compute By 1.概述 “Group By”从字面意义上理解就是根据“By”指定的规则对数据进行分组,所谓的分组就是将一个“数据集”划分成若干个“小区域”,然后针对若干个“小区域”进行数据处理. 2.原始表 3.简单Group By 示例1 select 类别,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyW7JE3.html" rel="bookmark">SQL查询语句 group by后， 字符串合并</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL查询语句 group by后, 字符串合并 合并列值 --******************************************************************************************* 表结构,数据如下: id value ----- ------ 1 aa 1 bb 2 aaa 2 bbb 2 ccc 需要得到结果: id values ------ ----------- 1 aa,bb 2 aaa,bbb,ccc 即:gr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0klOQd3.html" rel="bookmark">10g中HASH GROUP BY引起的临时表空间不足</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原本在9i上可以顺利完成的CTAS脚本,迁移到10g后运行总是报“ORA-1652: unable to extend temp segment by 128 in tablespace TS_HQY1_TEMP “无法扩展临时表空间的错误.应用人员表示该脚本涉及的数据量在迁移前后变化不大,而且令人匪夷所思的是在新的10g库上临时表空间大小已达40多个G,要远大于原9i库.很显然这不是由于临时表空间过小导致的该问题,更多的原因肯定是出在迁移后Oracle不同的行为方式上. 该脚本每月执行一次用以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBzzKvM.html" rel="bookmark">Grails中使用Ajax</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				grails中很好的集成了Ajax,这里介绍利用Jquery的 getJSON方法进行Ajax异步传输. 使用步骤: 引入Jquery(.gsp 页面中引入 jquery.js) &lt;script type=&quot;text/javascript&quot; src=&quot;${resource(dir: 'assets/js', file: 'jquery.js')}&quot;&gt;&lt;/script&gt; Javascript 脚本中添加Ajax调用方法 function isP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n8Kwx4.html" rel="bookmark">Linq中join &amp;amp&semi; group join &amp;amp&semi; left join 的用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linq中join &amp; group join &amp; left join 的用法 2013-01-30 11:12 12154人阅读 评论(0) 收藏 举报  分类: C#(14)  文章转自:http://www.cnblogs.com/c-jquery-linq-sql-net-problem/archive/2011/01/17/LINQ_Inner_Join_Group_Join_Left_Join.html 我们在做SQL查询的时候经常会用到Inner Join,Left Join,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzNWzkM.html" rel="bookmark">转载 sql中的group by 和 having 用法解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				sql中的group by 和 having 用法解析 --sql中的group by 用法解析:-- Group By语句从英文的字面意义上理解就是“根据(by)一定的规则进行分组(Group)”.--它的作用是通过一定的规则将一个数据集划分成若干个小的区域,然后针对若干个小区域进行数据处理.--注意:group by 是先排序后分组:--举例子说明:如果要用到group by 一般用到的就是“每这个字” 例如说明现在有一个这样的表:每个部门有多少人 就要用到分组的技术select Depar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/7MVQ6w4.html" rel="bookmark">算法学习 - 表达树的建立（后缀表达式法），树的先序遍历，中序遍历，后序遍历</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				表达树就是根据后缀表达式来建立一个二叉树. 这个二叉树的每个叶子节点就是数,真祖先都是操作符. 通过栈来建立的,所以这里也会有很多栈的操作. 树的先序遍历,中序遍历,后序遍历的概念我就不讲了,不会的自行百度,不然也看不懂我的代码. 下面是代码: // // main.cpp // expressionTree // // Created by Alps on 14-7-29. // Copyright (c) 2014年 chen. All rights reserved. // #includ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/NMyvgV0.html" rel="bookmark">MySQL在windows系统中修改datadir路径后无法启动问题，报错1067</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				windows server2008下如何更改MySQL数据库的目录的帖子已经很多了,这里简单介绍一个步骤,如果不成功请先查看其它帖子. 更改默认的mysql数据库目录 将 C:\Documents and Settings\All Users\Application Data\MySQL\MySQL Server 5.1\data 改到 D:\MysqlData 1. 建立文件夹 D:\MysqlData 2. 停止 mysql 服务,将 &quot;C:\Documents and Settings\			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQB5D3.html" rel="bookmark" class="title">匹配特定数字串</a>
					<div>
						定义一个file.txt文件,包含内容如下 $ cat file.txt 987-123-4567 123 456 7890 (123) 456-7890 222122-213-321 21 231- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RYYbqM.html" rel="bookmark" class="title">sdfasdgaghaerhasrtjhsrtj</a>
					<div>
						http://www.efu.com.cn/wenda/Question-11810.html http://www.efu.com.cn/wenda/Question-11812.html http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5kk84.html" rel="bookmark" class="title">android listView的item 显示多种不同的布局</a>
					<div>
						1.这篇博文不算什么知识点.使用的都是的系统中已经提供给我们的方式方法.这是最近用到了,感觉很实用,特此贡献出来. 首先需要定义,listview中需要展示的view个数,和view的布布局类型 pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rERdw0.html" rel="bookmark" class="title">Redis之HASH</a>
					<div>
						HASH 哈希 Redis hash 是一个string类型的field和value的映射表,hash特别适合用于存储对象. Redis 中每个 hash 可以存储 232 - 1 键值对(40多亿) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5K7B3.html" rel="bookmark" class="title">python成长之路第三篇&lpar;1&rpar;&lowbar;初识函数</a>
					<div>
						目录: 函数 1.为什么要使用函数 2.什么是函数 3.函数的返回值 4.文档化函数 5.函数传参数 文件操作(二) 1.文件操作的步骤 2.文件的内置方法 函数: 一.为什么要使用函数 在日常写代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDozVn4.html" rel="bookmark" class="title">登录checklist</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWzwD4.html" rel="bookmark" class="title">getAttribute与getAttribute的区别</a>
					<div>
						getParameter得到的是字符串,其取值源于jsp页面,从jsp页面中接受一个存在的参数,多用于servlet中,用于判断业务的类型和跳转页面.如: request.getParameter(& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5XbB3.html" rel="bookmark" class="title">数据结构-快速排序（C&num;实现）</a>
					<div>
						快速排序的主要思路: 1.在数组首尾处各设一个标记 2.取出数组第一个值作为中枢值 3.所有数据跟中枢值比较:比中枢值小的放中枢值左边,首部标记++往右推一位,大的放中枢值右边,尾部标记--往左推一位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekK8g4.html" rel="bookmark" class="title">Cocoapods   pod update更新第三方库后出现 file not found 问题解决方法！</a>
					<div>
						Cocoapods,pod update更新第三方库后第三方库已经下载到项目中,但在引用头文件时出现 file not found  问题 ! 解决方法:Cocoapods使用链接:http://ww ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnONZ0.html" rel="bookmark" class="title">Centos 7 配置pptp vpn</a>
					<div>
						1.配置epel yum 源 http://www.cnblogs.com/wangshuyi/p/6150575.html 2.过滤软件包安装 yum install NetworkManager- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rB1jw3.html" rel="bookmark" class="title">POJ - 2481 - Cows            （树状数组&plus;排序！！）</a>
					<div>
						Cows Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 13304   Accepted: 4407 Description ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wpnQl4.html" rel="bookmark" class="title">&lbrack;2-SAT&rsqb; poj 3678 Katu Puzzle</a>
					<div>
						题目链接: http://poj.org/problem?id=3678 Katu Puzzle Time Limit: 1000MS   Memory Limit: 65536K Total Sub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkklV3.html" rel="bookmark" class="title">Struts2开发环境搭建</a>
					<div>
						1.导入jar包:复制Struts\apps\struts2-blank\WEB-INF\lib下的所有jar包到当前项目的lib文件夹下 2.在web.xml文件中配置struts2:复制strut ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47z2Gx3.html" rel="bookmark" class="title">gogoprotobuf使用</a>
					<div>
						在go中使用google protobuf,有两个可选用的包goprotobuf(go官方出品)和gogoprotobuf. gogoprotobuf是完全兼容google protobuf,而且经过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vAopa0.html" rel="bookmark" class="title">java 导出excel表格数据</a>
					<div>
						本篇文章基于java把数据库中的数据以Excel的方式导出,欢迎各位大神吐槽: 1.基于maven jar包引入如下: 1 &lt;dependency&gt; 2 &lt;groupId&gt;ne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K7nvO0.html" rel="bookmark" class="title">Android属性动画Property Animation系列三之LayoutTransition（布局容器动画）</a>
					<div>
						在上一篇中我们学习了属性动画的ObjectAnimator使用,不了解的可以看看 Android属性动画Property Animation系列一之ObjectAnimator.这一篇我们来学点新的东 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vX2n6M.html" rel="bookmark" class="title">OpenStack&lowbar;Swift源代码分析&mdash;&mdash;ObjectReplicator源代码分析&lpar;2&rpar;</a>
					<div>
						1.Replicator运行代码具体分析 上篇问中介绍了启动Replicator的详细过程,以下解说Replicator的运行代码的详细实现,首先看replicate方法: def replicate ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xDZBD0.html" rel="bookmark" class="title">No unique bean of type &lbrack;net&period;shougongfang&period;action&period;paymoney&period;AlipayPayMoneyReturnObj&rsqb; is defined&colon; Unsat</a>
					<div>
						0 你把@Service放到实现类上吧.这个问题好像不止一个人在问啦 2013年10月25日 10:34 shidan66 30 0 1 1 加入评论 00 1,@service放到实现上 2.在xm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YpyqyM.html" rel="bookmark" class="title">Linux&lpar; CentOS 6&period;6 &rpar; 环境下使用 MONO &plus; Jexus 配置 ASP&period;NET 以及MVC运行环境</a>
					<div>
						1.本机环境如下图所示:(centOS 6.6) 2.使用yum安装必要的软件包(本机yum源是阿里云的配置): yum -y install gcc gcc-c++ bison pkgconfig  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBDZ6y3.html" rel="bookmark" class="title">人件札记：软件开发的管理思想</a>
					<div>
						前言:独处一室,的确有些寂寞,也有些浪费,不习惯这种感觉,就如同穿上了新衣服,却没有人称赞的那种寂寞.一言以蔽之,&quot;光杆司令不好当啊&quot;.90平的办公室,虽然充斥着电脑.桌子.椅子. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
